function [fpsi_n,fphi_n] = add_global_noise(fpsi,fphi,ln)

% Adds noise to the modulus of the wavelet transform
% Inputs :
% - fpsi : modulus of the wavelet transform
% - fphi : low-frequency component
% - ln : relative noise (in l2-norm)

noise_psi = randn(size(fpsi)) ;
noise_phi = (randn(size(fphi))+i*randn(size(fphi)))/sqrt(2) ;

noise_norm = sqrt(sum(abs(noise_psi(:)).^2)+sum(abs(noise_phi).^2)) ;
transf_norm = sqrt(sum(abs(fpsi(:)).^2) + sum(abs(fphi).^2)) ;

fpsi_n = abs(fpsi+ln*transf_norm/noise_norm*noise_psi) ;
fphi_n = fphi + ln*transf_norm/noise_norm*noise_phi ;